/***************************************************************/
/***************************************************************/
/*  $Header$  */
/***************************************************************/
/***************************************************************/

#ifndef  MONET_GENERAL_H
#define  MONET_GENERAL_H

/***********************************************************/
/*  Use of function prototypes                             */
/***********************************************************/

#ifndef MONET_PROTOTYPES
#if defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#define MONET_PROTOTYPES
#endif
#endif

#ifdef MONET_PROTOTYPES
#define PR(prototype) prototype
#else
#define PR(prototype) ()
#endif

/***********************************************************/
/*  Originally developed using X11R3, so need XAW_BC flag  */
/*  No longer works without X11R4, so X11R4 must be set.   */
/*  !!! Convert everything to X11R4, so that it works      */
/*  !!! X11R5 etc                                          */
/***********************************************************/

#define XAW_BC
#define X11R4

/***********************************************************/
/*  Originally thought about using various different SNMP  */
/*  libraries but as I can include the CMU stuff in this   */
/*  distribution without signing bits of paper etc, I'll   */
/*  stick with it.   In addition, it seems to compile on   */
/*  several machines with no problems at all.              */
/***********************************************************/

#define CMU_SNMP

/***********************************************************/
/***********************************************************/
/*  Standard include files and externals                   */
/***********************************************************/
/***********************************************************/

#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <assert.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/time.h>
#ifdef sun
#include <malloc.h>
#else
extern char * malloc PR((unsigned)), * realloc PR((char *, unsigned));
#endif
extern int errno;
extern char* getenv ();
extern long int        atol(/* const char *nptr */);
extern int             atoi(/* const char *nptr */);

/**********************************************************/
/*  gethostbyname  */
/**********************************************************/

#if defined(sun) || defined(ultrix)
#define herror()  MonetPrintfError("Error in gethostbyname/addr");
#endif

extern int h_errno;	

/**********************************************/
/*  X11R3/X11R4/DECwindows/ compatibility    */
/*  or for programs with no Windows           */
/**********************************************/

#if defined(NOX11)
typedef int Boolean;
typedef char * String;
typedef unsigned int unsigned;
#else
#include <X11/Intrinsic.h>
#endif

typedef Boolean MonetBool;

/***********************************************************/
/***********************************************************/

#include <monet/msh/String.h>
#include <monet/msh/File.h>
#include <monet/msh/StringTable.h>
#include <monet/msh/LinkList.h>
#include <monet/msh/Io.h>
#include <monet/msh/Info.h>

/**********************************************/
/*  Default monet functions  */
/**********************************************/

#define MONETMIN(a,b) (((a) < (b)) ? (a) : (b))

extern long MonetMin PR((long, long));

extern unsigned  MonetLog2
  PR((unsigned));

extern unsigned  MonetSqrt
  PR((unsigned));

/*  Use this after setting every thing else up */
extern void    Monet_user_config
  PR((unsigned argc, String * argv));
extern void    Monet_init
  PR((char * program, MonetFinishRoutine finish,
      char * config_file, char * directory,
      int argc, char ** argv));
extern void	Monet_quit    PR((int status));
extern void	Monet_finish  PR((void));

/**********************************************************
  Debugging stuff
  **********************************************************/

extern void Monet_debug_on  PR((unsigned level));
extern unsigned Monet_debug  PR((void));

#ifdef MonetDebug
#define MONETDEBUG(args) { MonetPrintfDebug args; }
#else
#define MONETDEBUG(args)
#endif

/**********************************************************/
/**********************************************************/

#endif  /* MONET_GENERAL_H */

/***************************************************************/
/***************************************************************/
/*  $Header$  */
/***************************************************************/
/***************************************************************/

