/***************************************************************/
/***************************************************************/
/*  $Header$  */
/***************************************************************
 I/O functions  
 **************************************************************/

#ifndef MONET_IO_H
#define MONET_IO_H

typedef void (* ConfirmRoutine) PR((void));
typedef void (* MonetStderrProc) PR((char *, char *, int len));
typedef void (* MonetStdoutProc) PR((char *, int len));
typedef void (* MonetConfirmProc) PR((ConfirmRoutine, char *));
typedef void (* MonetFinishRoutine) PR((void));

extern void MonetFwrite
  PR ((char * buf, int len));
extern void MonetErrFwrite
  PR ((char * buf, int len));
extern void MonetPrintf
  PR((char *, ...));
extern void MonetPError
  PR((char *, ...));
extern void MonetPrintfInform
  PR((char *, ...));
extern void MonetPrintfWarning
  PR((char *, ...));
extern void MonetPrintfError
  PR((char *, ...));
extern void MonetPrintfnl
  PR((char *, ...));
extern void MonetErrPrintfnl
  PR((char *, ...));

extern void Monet_confirm PR((ConfirmRoutine, char * message));
extern MonetConfirmProc set_confirm_box_routine PR((MonetConfirmProc));
extern MonetStderrProc MonetStderrProc_set PR((MonetStderrProc));
extern MonetStdoutProc MonetStdoutProc_set PR((MonetStdoutProc));

#ifndef ultrix
/* Haven't used varargs with the implementation !!! */

extern void MonetSysError
  PR((char *, ...));
extern void MonetSysWarn
  PR((char *, ...));
extern void MonetPrintfDebug
  PR((unsigned, char *, ...));

#endif

#endif

/***************************************************************/
/***************************************************************/
/*  $Header$  */
/***************************************************************/
/***************************************************************/
