


#ifndef MONET_MonetOrdSet_H_
#define MONET_MonetOrdSet_H_

/**********************************************************/
/*  Maintain a simple extendable list                     */
/**********************************************************/

typedef struct monet_ordset * MonetOrdSet;
#define NULSET ((MonetOrdSet) 0)

/**********************************************************
  Prototype for searching scanning whole list
  Because an element could be deleted we check this by reading
  from the same place again, if changed than the element was
  removed if not we read the next one in the sequence.
  **********************************************************/

#define FOR_ORDSET(o,list,type) \
{ unsigned ordset_pos = 0; \
  for (o= (type)getN_MonetOrdSet (list, ordset_pos); o; \
       o = (type)check_getN_MonetOrdSet (list, &ordset_pos, o)) {

#define END_FORLIST  }}

/**********************************************************/
/*  Functions  */
/**********************************************************/

extern MonetBool	extract_MonetOrdSet	PR((MonetOrdSet, caddr_t));
extern MonetOrdSet	create_MonetOrdSet	PR((void));
extern void		reset_MonetOrdSet	PR((MonetOrdSet));
extern void		free_MonetOrdSet	PR((MonetOrdSet));
extern void		insert_MonetOrdSet	PR((MonetOrdSet, caddr_t));
extern MonetBool	isEmpty_MonetOrdSet	PR((MonetOrdSet));
extern caddr_t		getN_MonetOrdSet	PR((MonetOrdSet, unsigned));
extern caddr_t		check_getN_MonetOrdSet
  PR((MonetOrdSet, unsigned* place, caddr_t previous));
extern caddr_t		first_MonetOrdSet	PR((MonetOrdSet));
extern caddr_t		next_MonetOrdSet	PR((MonetOrdSet));
extern unsigned		sizeOf_MonetOrdSet	PR((MonetOrdSet));
extern caddr_t		second_MonetOrdSet	PR((MonetOrdSet));
extern MonetBool	isMember_MonetOrdSet	PR((MonetOrdSet, caddr_t));

#endif
