
#ifndef MONET_XIO_WIDGET_H
#define MONET_XIO_WIDGET_H

#include <Wc/WcCreate.h>
#include <monet/x/X11.h>
#include <monet/x/Report.h>
#include <monet/x/Draw.h>

#if !defined(X11R4)
typedef Opaque XtPointer;
#endif

/****************************************************************************/
/*  Exported global variables  */
/****************************************************************************/

extern Widget          XmonetTopWidget;
extern XtAppContext    XmonetAppCon;
extern Display        *XmonetDisplay;
extern Widget          XmonetCurrentWidget;
extern XEvent         *XmonetCurrentEvent;
extern Position        XmonetCurrentX, XmonetCurrentY;

#define MAXDIMENSION ((((1<<(8*sizeof (Dimension)-1)) - 1) << 1) + 1)

/****************************************************************************/
/*  For creating a Callback procedures  */
/****************************************************************************/

#define CALLBACK(name) \
	static void name (widget, client_data, call_data)  \
	Widget widget; \
	XtPointer client_data; \
	XtPointer call_data; \
	{

#define ENDCB }

#define DECLARECB(name) \
  extern void name PR((Widget, XtPointer, XtPointer));

/****************************************************************************/
/*  Register callback  */
/****************************************************************************/

#define RCALL(name, func, client) \
  WcRegisterCallback(XmonetAppCon, name, func, client)

/****************************************************************************/
/*  For creating Action procedures  */
/****************************************************************************/

#define ACTION(name, params_required) \
	static void name (widget,event,params,num_params) \
	Widget widget; \
	XEvent *event; \
	String *params; \
	unsigned *num_params; \
	{ {
#define ENDACT }}

#define DECLARE_ACTION(name) \
  extern void name \
  PR((Widget, XEvent *, String *, Cardinal *));

/****************************************************************************/
/*  Prototypes  */
/****************************************************************************/

extern void init_xmonet_script
  PR((void));

extern void finish_xmonet_script
  PR((void));

extern void	Widget_get_dimensions
  PR((Widget, Position *x,Position *y, Dimension * width, Dimension * height));

extern String	get_dialogWidgetValue
  PR((Widget));

extern void	XMonet_EventLoop
  PR((void));

extern MonetBool	XMonet_init
  PR((String app_class, int argc, char** argv));

extern String	DoCommandToString
  PR((char ** argv, char ** errors));

extern String	XmonetWidget2value
  PR((String));

extern Widget	XmonetWidget2Popup
  PR((Widget, String));

extern void	Xmonet_put_widget
  PR((Widget, String, int len));

extern ShellWidget XmonetShellAncestor
     PR((Widget, MonetBool toplevel));

extern String	TextWidget_set_value
  PR((Widget widget, String w_name, String value));

extern MonetBool	XMonetSetWidgetPixmap
  PR((String name, MonetBool set_sides, char * bits, Cardinal, Cardinal));

extern void XMonetPopupCentral
  PR((Widget parent, Widget popup, XtGrabKind grab));

extern void Xmonet_sizing_cursor
  PR((Widget));
extern void Xmonet_normal_cursor
  PR((Widget));
extern void Xmonet_wait_cursor
  PR((Widget));
extern void Xmonet_exec_cursor
  PR((Widget));

extern MonetBool Xmonet_pointer
  PR((Widget, Position *x, Position *y));

extern XtGeometryResult XtMakeGeometryRequest
  PR((Widget widget, XtWidgetGeometry *request, XtWidgetGeometry *reply));

extern Widget Xmonet_get_widget
  PR((char *));

extern Widget Xmonet_sub_widget
  PR((String name, WidgetClass wclass, char * class_name));

#endif

